package cn.estsh.i3plus.pojo.mes.bean;


import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Index;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @Description:
 * @Reference:
 * @Author: jessica.chen
 * @CreateDate: 2019\11\15 10:01
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_QC_ORDER_RECORD", indexes = {
        @Index(columnList = "QC_ORDER_DETAIL_ID"),
        @Index(columnList = "SERIAL_NUMBER"),
        @Index(columnList = "ORDER_NO")
})
@Api("MES_检验单检验记录")
public class MesQcOrderRecord extends BaseBean implements Serializable {
    private static final long serialVersionUID = -5245624982023882232L;

    @Column(name = "ORDER_NO")
    @ApiParam("质检单号")
    private String orderNo;

    @Column(name = "CHECK_RESULT")
    @ApiParam("判定结果")
    private Integer checkResult = 0;

    @Column(name = "CHECK_VALUE")
    @ApiParam("检测值")
    private String checkValue;

    @Column(name = "SERIAL_NUMBER")
    @ApiParam("产品条码")
    private String serialNumber;

    @Column(name = "CHECK_SEQ")
    @ApiParam("检测顺序")
    private Integer checkSeq;

    @Column(name = "QC_ORDER_DETAIL_ID")
    @ApiParam("质检单明细id")
    private Long qcOrderDetailId;

}
